/*========================================================================
 * Written by D. Jason Penney, 1991.  Rights to this program are as follows:
 * you may not receive any compensation for distribution of this program
 * except for an optional fee for the distribution medium.  This program
 * must be accompanied by this source code.  This notice may not be removed.
 * Modifications to this program must be clearly noted and marked as such.
 * Since this program is provided free of charge, there is ABSOLUTELY NO
 * WARRANTY.
 *
 * Name - getservbyname.c
 *
 * Description - Program to verify presence of a given service, i.e.
 *               by the getservbyname(2) call.
 *
 *========================================================================
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#if defined(macintosh)
#include "global.ht"
#include "tnetmac.hf"
#else
#include <netdb.h>
#endif
#include <ctype.h>
#include <errno.h>

#if !defined(macintosh)
#include <sys/types.h>
#include <netinet/in.h>
#endif

int main(int argc, char *argv[])
{
struct servent *thisOne;
char **thisAlias;
char s[BUFSIZ];

#if defined(macintosh)
char *p;

printf("Service name: ");
fflush(stdout);
if (fgets(s, sizeof(s), stdin) == NULL)
   exit(1);
if ( (p = strchr(s, '\n')) != NULL)
  *p = '\0';
TnetInitMacTCP();

#else
if (argc != 2) {
  printf("Usage: %s <service-name>\n", argv[0]);
  exit(1);
  }
strncpy(s, argv[1], sizeof(s));
#endif

  thisOne = getservbyname(s, NULL);

if (thisOne == NULL) {
  printf("%s:  (no entry, errno = %d)\n", s, errno);
  exit(1);
  }
printf("s_name=%s s_port = %d s_proto = %s\n", thisOne->s_name, 
    ntohs(thisOne->s_port), thisOne->s_proto);
if (*thisOne->s_aliases != NULL) {
  printf("aliases: ");
  for (thisAlias = thisOne->s_aliases; *thisAlias != NULL; thisAlias ++)
    printf("%s ", *thisAlias);
  printf("\n");
  }

#if defined(macintosh)
TnetShutdownMacTCP();
#endif

return 0; /* for lint */
}
