Extension { #name : 'SymbolAssociation' }

{ #category : 'Private' }
SymbolAssociation >> _resolveRcConflictsWith: conflictObjects [

"A logical write-write conflict has occurred on the receiver.  This
 may have occurred due to artificially placing the receiver in the write
 set when a subclass re-implemented this method (this is done to maintain
 cache coherency. See if the state has changed in this transaction.  If
 so, then it is a valid conflict (and returns false); otherwise returns true."

| preAbortValue |
preAbortValue := value.
self _selectiveAbort.
^ value == preAbortValue

]

{ #category : 'Accessing' }
SymbolAssociation >> key: aKey [

"Sets the object aKey as the key of the receiver, after checking
 constraints."

 (aKey _isSymbol ) ifTrue:[
   key := aKey .
 ] ifFalse:[
   ArgumentTypeError new constrainedIv: 'SymbolAssociation.key'
	  expectedClass: Symbol actualArg: aKey ;
     signal
 ]

]

{ #category : 'Updating' }
SymbolAssociation >> key: aKey value: aValue [


"Sets the object aKey as the key of the receiver, and the object aValue as the
 value of the receiver."

 self key: aKey .  "message send to enforce constraints"
 value := aValue .

]
