"
The class LogEntry implements GemStone internals. It is not intended for 
customer use, by creating instances or by subclassing.
"
Class {
	#name : 'LogEntry',
	#superclass : 'Object',
	#instVars : [
		'receiver',
		'selector',
		'argArray'
	],
	#gs_reservedoop : '92161',
	#category : nil
}

{ #category : 'Accessing' }
LogEntry >> argArray [

"Returns the value of the instance variable 'argArray'."

^argArray

]

{ #category : 'Updating' }
LogEntry >> argArray: newValue [

"Modify the value of the instance variable 'argArray'."

argArray := newValue

]

{ #category : 'Replaying' }
LogEntry >> printObj: object [
  object isSpecial ifTrue:[
    ^ '(', object class name,' ', object asString,') '.
  ] ifFalse:[
    ^ ' ', object asOop asString,'(a ', object class name,') '
  ]
]

{ #category : 'Formatting' }
LogEntry >> printOn: aStream [

"Puts a displayable representation of the receiver on the given stream."

aStream tab; nextPutAll: '(', selector printString, ' withArgs: '; cr.
argArray do: [:obj |
    aStream tab; tab; nextPutAll: ' [', obj class printString, ', ', obj asOop printString, '] '; cr.
].
aStream tab; nextPutAll: ')'; cr.

]

{ #category : 'Accessing' }
LogEntry >> receiver [

"Returns the value of the instance variable 'receiver'."

^receiver

]

{ #category : 'Updating' }
LogEntry >> receiver: newValue [

"Modify the value of the instance variable 'receiver'."

receiver := newValue

]

{ #category : 'Replaying' }
LogEntry >> redo [

"Replays the message send for the receiver log entry."

System _gemCommitConflictDetails
  ifTrue: [ 
    | str sz |
    str :=  '--- LogEntry redo( ' , (self printObj: receiver), selector printString, ' args:(' .
    1 to: (sz := argArray size) do:[:n | | elem |
      elem := argArray at: n .
      str addAll: ( self printObj: elem) .
      n < sz ifTrue:[ str add: $, ].
    ].
    str add: '))' .
    GsFile gciLogServer:str ] .
^ receiver perform: selector withArguments: argArray
]

{ #category : 'Accessing' }
LogEntry >> selector [

"Returns the value of the instance variable 'selector'."

^selector

]

{ #category : 'Updating' }
LogEntry >> selector: newValue [

"Modifies the value of the instance variable 'selector'."

selector := newValue

]
